;This NCL code is used for interpolate variable from the coordinates of ERA-interim 
;to the coordinates of the particular WRF run in this study.


load  "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
load  "$NCARG_ROOT/lib/ncarg/nclscripts/esmf/ESMF_regridding.ncl"
load  "$NCARG_ROOT/lib/ncarg/nclscripts/contrib/cd_string.ncl"
begin

do year = 0,1
   YYYY=sprinti("%4i",year+1980)
     
  f     = addfile ("/archive/u1/uaf/lcai4/WRF_forcing/PWRFout_1980_type3.nc", "r")
   lat2d = f->latitude    ;read the lat and lon of WRF run, which is a curvilinear coordiante
   lon2d = f->longitude   ;so it's called lon2d/lat2d
   ;read the ERA-interim lon/lat, which is 1D, and also the variables that needs to be interpolated. 
   fccm  = addfile ("/archive/u1/uaf/lcai4/matlab/source_data/ERAout_"+YYYY+".nc", "r") ;ERA common variables (T,TD,U,V)
 ;   fccm  = addfile ("/archive/u1/uaf/lcai4/NCL_workspace/ERA_SNOW_"+YYYY+".nc", "r")  ;ERA snow variables
   T2     = fccm->T2
   TD2    = fccm->TD2
   U10    = fccm->U10
   V10    = fccm->V10
 ;   SNOW_DEPTH = fccm->SNOW_DEPTH
 ;   SNOW_DENSITY = fccm->SNOW_DENSITY 
 ;  SI2    = fccm->SI2
 ;  print(x)
   lat   = fccm->lat
   lon   = fccm->lon
   time  = fccm->time
 ;  hour  = fccm->hour
    lon=lon-360    ;ERA-interim's longitude is from 0 to 360, so it need conversion to fit WRF's longitude. 
    lat=lat(::-1)
   opt    =    True
  

  opt@SrcFileName     = "ERA_interim.nc"

  opt@DstFileName     = "WRF1980.nc"
  opt@WgtFileName     = "ERA2WRF_patch.nc"
  opt@ForceOverwrite  = True
  opt@InterpolationMethod = "bilinear"
  opt@DstGridLat = lat2d
  opt@DstGridLon = lon2d
 
  opt@SrcGridLat = lat
  opt@srcGridLon = lon
  
   T2_interp  = ESMF_regrid(T2, opt)
   printVarSummary(T2_interp)
   TD2_interp = ESMF_regrid(TD2,opt)
   printVarSummary(TD2_interp)  
   U10_interp = ESMF_regrid(U10,opt)
   printVarSummary(U10_interp)
   V10_interp = ESMF_regrid(V10,opt)
   printVarSummary(V10_interp) 
;   SD_interp = ESMF_regrid(SNOW_DEPTH,opt)
;   printVarSummary(SD_interp)
;   SR_interp = ESMF_regrid(SNOW_DENSITY,opt)
;   printVarSummary(SR_interp)


;  print(xgrd)
;   SI2_interp = ESMF_regrid(SI2,opt)
;   printVarSummary(SI2_interp)
;;output file
   file1 = addfile("ERA_WRF_interp_"+YYYY+".nc","c")
;   file1 = addfile("ERA_WRF_interp_SNOW_"+YYYY+".nc","c")
  ; filedimdef(file1,"time",-1,true)
    
   
   file1->T2_interp = T2_interp
   file1->TD2_interp = TD2_interp
   file1->U10_interp = U10_interp
   file1->V10_interp = V10_interp
   file1->SI2_interp = SI2_interp
;    file1->SD_interp = SD_interp
;    file1->SR_interp = SR_interp
   file1->lat        = lat2d
   file1->lon        = lon2d 
   file1->T2_interp@units = "K"
   file1->TD2_interp@units = "K"
   file1->U10_interp@units = "m/s"
   file1->V10_interp@units = "m/s"
 ;   file1->SD_interp@units = "m"
 ;   file1->SR_interp@units = "kg m-3"
   file1@title = "NCL created"

   delete([/T2, TD2, U10, V10, lat, lon, time, hour, lat2d, lon2d, T2_interp, TD2_interp, U10_interp, V10_interp/])
 ;   delete([/SNOW_DEPTH, SNOW_DENSITY, lat, lon, time, lat2d, lon2d, SD_interp, SR_interp/])
   end do


   end
