function []=linear_scaling_ERA_WRF(year)
%%%%load the .mat files that storing the monthly climatology of ERA and ERA-WRF
load('/archive/u1/uaf/lcai4/matlab/source_data/ERA_monthly_climatology.mat');
load('/archive/u1/uaf/lcai4/matlab/source_data/ERA_WRF_climatology_type2.mat');
%%%%load the extracted 3-hourly WRF output files
s1=strcat('/archive/u1/uaf/lcai4/WRF_forcing/PWRFout_',num2str(year),'_type4.nc');
ncid1=netcdf.open(s1,'NC_NOWRITE');
 rain_WRF=netcdf.getVar(ncid1,0,[0 0 0 0],[179 149 365 8]);
 SNOWH_WRF=netcdf.getVar(ncid1,2,[0 0 0 0],[179 149 365 8]);
 SNOWR_WRF=netcdf.getVar(ncid1,3,[0 0 0 0],[179 149 365 8]);
 T2_WRF=netcdf.getVar(ncid1,6,[0 0 0 0],[179 149 365 8]);
 TD2_WRF=netcdf.getVar(ncid1,7,[0 0 0 0],[179 149 365 8]);
 U10_WRF=netcdf.getVar(ncid1,4,[0 0 0 0],[179 149 365 8]);
 V10_WRF=netcdf.getVar(ncid1,5,[0 0 0 0],[179 149 365 8]);
     %%%%calculating the ratio of the linear scaling method
     rain_ratio=mean(rain_ERA_monthly,4)./mean(rain_WRF_monthly,4);
     T2_ratio=mean(T2_ERA_monthly,4)-mean(T2_WRF_monthly,4);
     TD2_ratio=mean(TD2_ERA_monthly,4)-mean(TD2_WRF_monthly,4);
     U10_ratio=mean(U10_ERA_monthly,4)-mean(U10_WRF_monthly,4);
     V10_ratio=mean(V10_ERA_monthly,4)-mean(V10_WRF_monthly,4);
     SNOWH_ratio=mean(SNOWH_ERA_monthly,4)./mean(SNOWH_WRF_monthly,4);
     SNOWR_ratio=mean(SNOWR_ERA_monthly,4)-mean(SNOWR_WRF_monthly,4);
	 %%%%Defining matrixes of variables beforehand
     rain_BC(1:179,1:149,1:365,1:8)=0;
     T2_BC(1:179,1:149,1:365,1:8)=0;
     TD2_BC(1:179,1:149,1:365,1:8)=0;
     U10_BC(1:179,1:149,1:365,1:8)=0;
     V10_BC(1:179,1:149,1:365,1:8)=0;
     SNOWH_BC(1:179,1:149,1:365,1:8)=0;
     SNOWR_BC(1:179,1:149,1:365,1:8)=0;
for i=1:12
 month=[31,28,31,30,31,30,31,31,30,31,30,31];
 %%% calculating the start and the end DOY of each month
 if i==1
    d_strt=1;d_end=31;
   else 
     d_strt=1+sum(month(1:i-1));
     d_end=d_strt+month(i)-1;
 end
    %%%%% Linear scaling begins
        for day=d_strt:d_end
            disp(day);
        for hr=1:8
        rain_BC(:,:,day,hr)=squeeze(rain_WRF(:,:,day,hr)).*squeeze(rain_ratio(:,:,i));
        T2_BC(:,:,day,hr)=squeeze(T2_WRF(:,:,day,hr))+squeeze(T2_ratio(:,:,i));
        TD2_BC(:,:,day,hr)=squeeze(TD2_WRF(:,:,day,hr))+squeeze(TD2_ratio(:,:,i));
        U10_BC(:,:,day,hr)=squeeze(U10_WRF(:,:,day,hr))+squeeze(U10_ratio(:,:,i));
        V10_BC(:,:,day,hr)=squeeze(V10_WRF(:,:,day,hr))+squeeze(V10_ratio(:,:,i));
        SNOWH_BC(:,:,day,hr)=squeeze(SNOWH_WRF(:,:,day,hr)).*squeeze(SNOWH_ratio(:,:,i));
        SNOWR_BC(:,:,day,hr)=squeeze(SNOWR_WRF(:,:,day,hr))+squeeze(SNOWR_ratio(:,:,i));

        end
        end

end

 XLONG=netcdf.getVar(ncid1,13);
 XLAT=netcdf.getVar(ncid1,14);
 
nt=365;
nx=179;
ny=149;
nh=8;
time=1:nt;
hour=0:3:21;
disp('Create file Netcdf...')
disp(year)
filenc=strcat('PWRF_BC_',int2str(year),'_LS_type2.nc');    
ncid = netcdf.create(filenc,'64BIT_OFFSET');
% Create dimensions
dimid_lon = netcdf.defDim(ncid,'longitude',nx);
dimid_lat = netcdf.defDim(ncid,'latitude',ny); 
dimid_time = netcdf.defDim(ncid,'time',nt); 
dimid_hour = netcdf.defDim(ncid,'hour',nh);
% Create variables
varid_rain = netcdf.defVar(ncid,'rain','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_rain,'long_name','Total_precipitation')
netcdf.putAtt(ncid,varid_rain,'units','mm')
netcdf.putAtt(ncid,varid_rain,'missing_value',-9999)
%
varid_snowh = netcdf.defVar(ncid,'snowh','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_snowh,'long_name','snow_depth')
netcdf.putAtt(ncid,varid_snowh,'units','m')
netcdf.putAtt(ncid,varid_snowh,'missing_value',-9999)
%
varid_snowr = netcdf.defVar(ncid,'snowr','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_snowr,'long_name','snow density')
netcdf.putAtt(ncid,varid_snowr,'units','kg m-3')
netcdf.putAtt(ncid,varid_snowr,'missing_value',-9999)
% %
varid_U10 = netcdf.defVar(ncid,'U10','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_U10,'long_name','X_component_wind_speed')
netcdf.putAtt(ncid,varid_U10,'units','m/s')
netcdf.putAtt(ncid,varid_U10,'missing_value',-9999)
% %
varid_V10 = netcdf.defVar(ncid,'V10','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_V10,'long_name','Y_component_wind_speed')
netcdf.putAtt(ncid,varid_V10,'units','m/s')
netcdf.putAtt(ncid,varid_V10,'missing_value',-9999)
% %
varid_T2 = netcdf.defVar(ncid,'T2','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_T2,'long_name','2m_temperature')
netcdf.putAtt(ncid,varid_T2,'units','K')
netcdf.putAtt(ncid,varid_T2,'missing_value',-9999)
% %
varid_TD2 = netcdf.defVar(ncid,'TD2','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_TD2,'long_name','2m_dewpoint_temperature')
netcdf.putAtt(ncid,varid_TD2,'units','K')
netcdf.putAtt(ncid,varid_TD2,'missing_value',-9999)
%
varid_lon = netcdf.defVar(ncid,'longitude','double',[dimid_lon,dimid_lat]);
netcdf.putAtt(ncid,varid_lon,'long_name','Longitude')
netcdf.putAtt(ncid,varid_lon,'units','degrees_east')
% 
varid_lat = netcdf.defVar(ncid,'latitude','double',[dimid_lon,dimid_lat]);
netcdf.putAtt(ncid,varid_lat,'long_name','Latitude')
netcdf.putAtt(ncid,varid_lat,'units','degrees_north')
%
varid_time = netcdf.defVar(ncid,'time','double',dimid_time);
netcdf.putAtt(ncid,varid_time,'long_name','Time')
netcdf.putAtt(ncid,varid_time,'units','day')
% 
varid_hour = netcdf.defVar(ncid,'hour','double',dimid_hour);
netcdf.putAtt(ncid,varid_hour,'long_name','hour')
netcdf.putAtt(ncid,varid_hour,'units','hour')

netcdf.endDef(ncid)


 netcdf.putVar(ncid,varid_time,time);
 netcdf.putVar(ncid,varid_hour,hour);
 netcdf.putVar(ncid,varid_rain,rain_BC);
 netcdf.putVar(ncid,varid_snowh,SNOWH_BC);
 netcdf.putVar(ncid,varid_snowr,SNOWR_BC);
 netcdf.putVar(ncid,varid_T2,T2_BC);
 netcdf.putVar(ncid,varid_TD2,TD2_BC);
 netcdf.putVar(ncid,varid_U10,U10_BC);
 netcdf.putVar(ncid,varid_V10,V10_BC);
 netcdf.putVar(ncid,varid_lon,XLONG);
 netcdf.putVar(ncid,varid_lat,XLAT);

netcdf.close(ncid) 
clear all

